質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

89.85%

Django Mysqlを使用した埋め込みsql

受付中

回答 1

投稿 編集

  • 評価
  • クリップ 0
  • VIEW 404

tohokukagaku

score 10

前提・実現したいこと

下記のコード tests.py と models.pyを用意してコマンドプロントからpython tests.pyを実行すると以下のようなエラーが出てしまいます。

しかし試しにview.pyに以下のようなコードを作成し、コマンドプロントから manage.py runserverを実行し tes2.htmlテンプレートを利用したweb画面のボタンから実行してみた場合、正常に処理できました。

どうして test.pyからはデータベースを扱うことができないのでしょうか?

test.pyからテスト用の埋め込みsqlを作成し、サーバーをいちいち稼働することなく論理エラーや文法エラーが出るか試したいので,ご教授お願いいたします。

発生している問題・エラーメッセージ

Traceback (most recent call last):
  File "tests.py", line 2, in <module>
    import models
  File "C:\Python\mysite\myapp1\models.py", line 50, in <module>
    class Sqltes(models.Model):
  File "C:\Python\env1\lib\site-packages\django\db\models\base.py", line 87, in __new__
    app_config = apps.get_containing_app_config(module)
  File "C:\Python\env1\lib\site-packages\django\apps\registry.py", line 249, in get_containing_app_config
    self.check_apps_ready()
  File "C:\Python\env1\lib\site-packages\django\apps\registry.py", line 131, in check_apps_ready
    settings.INSTALLED_APPS
  File "C:\Python\env1\lib\site-packages\django\conf\__init__.py", line 57, in __getattr__
    self._setup(name)
  File "C:\Python\env1\lib\site-packages\django\conf\__init__.py", line 42, in _setup
    % (desc, ENVIRONMENT_VARIABLE))
django.core.exceptions.ImproperlyConfigured: Requested setting INSTALLED_APPS, but settings are not configured. You must either define the environment variable DJANGO_SETTINGS_MODULE or call settings.configure() before accessing settings.

該当のソースコード

# tests.py

import models

b =  Sqltes(id=4, name="new name4", testext="new text4" )
b.save()
# models.py

import datetime

from django.db import models
from django.utils import timezone

class Sqltes(models.Model):
    id = models.IntegerField(primary_key=True)
    name = models.CharField(max_length=255)
    testext = models.CharField(max_length=255, blank=True, null=True)

    class Meta:
        managed = False
        db_table = 'sqltes'
# views.py

from django.http import HttpResponse
from django.shortcuts import render
from . import forms

from .forms import MyForm
from .models import *

def tes_template(request):
    #変数の初期数値は設定しなければならない
    tes3 = ""
    if request.method == 'POST':
         b =  Sqltes(id=4, name="new name4", testext="new text4")
         b.save()
         b =  Sqltes.objects.get(pk=4)
         tes3 = b.name

    myapp_data = {
        "tes1" : tes3,
    }
    return render(request, 'tes2.html' , myapp_data)
# tes.html

<!DOCTYPE html>
<html lang="ja" dir="ltr">
  <head>
    <meta charset="utf-8">
    <title></title>
    <!-- UIkit CSS -->
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/uikit/3.0.0-beta.25/css/uikit.min.css" />

    <!-- jQuery is required -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>

    <!-- UIkit JS -->
    <script src="https://cdnjs.cloudflare.com/ajax/libs/uikit/3.0.0-beta.25/js/uikit.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/uikit/3.0.0-beta.25/js/uikit-icons.min.js"></script>
  </head>
  <body>
    <form class="" action="" method="post">
  {% csrf_token %} {# ← post を使う場合のおまじない#}

  <input class="uk-input" type="text" name="tes" value="">
  <input class="uk-text-large" type="submit" name="button" value="送 信">

   </form>

  </body>
</html>
"""
Django settings for mysite project.

Generated by 'django-admin startproject' using Django 2.1.5.

For more information on this file, see
https://docs.djangoproject.com/en/2.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/2.1/ref/settings/
"""

import os

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/2.1/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'r4+r_%h^q1y=oclmulfbzp=%0(4batna5o%&s!$n)c^4%-ur4h'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = []


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'myapp1',
    'crud', #追加分

]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'mysite.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [
                os.path.join(BASE_DIR, 'templates'),
            ],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'mysite.wsgi.application'


# Database
# https://docs.djangoproject.com/en/2.1/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.mysql',
        'NAME': 'test',               #データベース名
        'USER': 'mysql',              #ユーザー名
        'PASSWORD': 'パスワード',    #パスワード
        'HOST': 'IPアドレス',       #PCのIPアドレス(デフォルトは localhost )
        'PORT': 'ポート番号',               #ポート番号
    }
}


# Password validation
# https://docs.djangoproject.com/en/2.1/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/2.1/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'Asia/Tokyo'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/2.1/howto/static-files/

STATIC_URL = '/static/'

Django

試したこと

ここに問題に対して試したことを記載してください。

Command==0.1.0
Django==2.1.5
django-uikit-admin==0.1.1
django-uikit-editor==0.0.1
pytz==2018.9
Python 3.6.5

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

質問への追記・修正、ベストアンサー選択の依頼

  • t_obara

    2019/03/18 17:36

    test時にテーブルがないと言われているので、テストように準備したDBの中に利用するテーブルがないのでしょう?それはいつ作るのですか?

    キャンセル

  • tohokukagaku

    2019/03/18 18:15

    すみません。その設定のやり方を詳しく教えていただけませんか?
    テスト開始したらdjangoの方で自動でテスト用のdbとテーブルを作成して、終わったら消されるのだと思っていましたので。

    キャンセル

  • t_obara

    2019/03/18 18:48

    なるほど。すでに回答されている通りで、テスト実行方法がそこに記載のリンクに示された方法で実行されていないのでは?
    $ python manage.py test polls

    キャンセル

回答 1

0

エラー文に書いてあるとおり、Djangoのモデルを扱うには、INSTALLED_APPS等を設定ファイルから読み込む必要があるためです。

django.core.exceptions.ImproperlyConfigured: Requested setting INSTALLED_APPS, but settings are not configured. You must either define the environment variable DJANGO_SETTINGS_MODULE or call settings.configure() before accessing settings.

とはいえ、テストのために毎回サーバを動かすのは面倒、と感じるのはもっともなことです。
Djangoにはユニットテスト機能がついているので、これを使ってモデルやビューをテストしてみてください。

https://docs.djangoproject.com/ja/2.1/intro/tutorial05/

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2019/03/11 16:14 編集

    回答してくださりありがとうございます。
    リンク先の情報に従いコードを下記のように修正しました。
    ```django
    import datetime

    from django.test import TestCase
    from django.utils import timezone

    from .models import *

    class Tests(TestCase):

    def test(self):
    b = Sqltes(id=5, name="new name5", testext="new text5" )
    b.save()
    ```

    しかし、下記のようなエラーが出てしまいました。
    ```コマンドプロント
    Creating test database for alias 'default'...
    System check identified no issues (0 silenced).
    E
    ======================================================================
    ERROR: test (myapp1.tests.Tests)
    ----------------------------------------------------------------------
    Traceback (most recent call last):
    File "C:\Python\env1\lib\site-packages\django\db\backends\utils.py", line 85, in _execute
    return self.cursor.execute(sql, params)
    File "C:\Python\env1\lib\site-packages\django\db\backends\mysql\base.py", line 71, in execute
    return self.cursor.execute(query, args)
    File "C:\Python\env1\lib\site-packages\pymysql\cursors.py", line 170, in execute
    result = self._query(query)
    File "C:\Python\env1\lib\site-packages\pymysql\cursors.py", line 328, in _query
    conn.query(q)
    File "C:\Python\env1\lib\site-packages\pymysql\connections.py", line 517, in query
    self._affected_rows = self._read_query_result(unbuffered=unbuffered)
    File "C:\Python\env1\lib\site-packages\pymysql\connections.py", line 732, in _read_query_result
    result.read()
    File "C:\Python\env1\lib\site-packages\pymysql\connections.py", line 1075, in read
    first_packet = self.connection._read_packet()
    File "C:\Python\env1\lib\site-packages\pymysql\connections.py", line 684, in _read_packet
    packet.check_error()
    File "C:\Python\env1\lib\site-packages\pymysql\protocol.py", line 220, in check_error
    err.raise_mysql_exception(self._data)
    File "C:\Python\env1\lib\site-packages\pymysql\err.py", line 109, in raise_mysql_exception
    raise errorclass(errno, errval)
    pymysql.err.ProgrammingError: (1146, "Table 'test_test.sqltes' doesn't exist")

    The above exception was the direct cause of the following exception:

    Traceback (most recent call last):
    File "C:\Python\mysite\myapp1\tests.py", line 15, in test
    b.save()
    File "C:\Python\env1\lib\site-packages\django\db\models\base.py", line 718, in save
    force_update=force_update, update_fields=update_fields)
    File "C:\Python\env1\lib\site-packages\django\db\models\base.py", line 748, in save_base
    updated = self._save_table(raw, cls, force_insert, force_update, using, update_fields)
    File "C:\Python\env1\lib\site-packages\django\db\models\base.py", line 812, in _save_table
    forced_update)
    File "C:\Python\env1\lib\site-packages\django\db\models\base.py", line 861, in _do_update
    return filtered._update(values) > 0
    File "C:\Python\env1\lib\site-packages\django\db\models\query.py", line 712, in _update
    return query.get_compiler(self.db).execute_sql(CURSOR)
    File "C:\Python\env1\lib\site-packages\django\db\models\sql\compiler.py", line 1383, in execute_sql
    cursor = super().execute_sql(result_type)
    File "C:\Python\env1\lib\site-packages\django\db\models\sql\compiler.py", line 1065, in execute_sql
    cursor.execute(sql, params)
    File "C:\Python\env1\lib\site-packages\django\db\backends\utils.py", line 68, in execute
    return self._execute_with_wrappers(sql, params, many=False, executor=self._execute)
    File "C:\Python\env1\lib\site-packages\django\db\backends\utils.py", line 77, in _execute_with_wrappers
    return executor(sql, params, many, context)
    File "C:\Python\env1\lib\site-packages\django\db\backends\utils.py", line 85, in _execute
    return self.cursor.execute(sql, params)
    File "C:\Python\env1\lib\site-packages\django\db\utils.py", line 89, in __exit__
    raise dj_exc_value.with_traceback(traceback) from exc_value
    File "C:\Python\env1\lib\site-packages\django\db\backends\utils.py", line 85, in _execute
    return self.cursor.execute(sql, params)
    File "C:\Python\env1\lib\site-packages\django\db\backends\mysql\base.py", line 71, in execute
    return self.cursor.execute(query, args)
    File "C:\Python\env1\lib\site-packages\pymysql\cursors.py", line 170, in execute
    result = self._query(query)
    File "C:\Python\env1\lib\site-packages\pymysql\cursors.py", line 328, in _query
    conn.query(q)
    File "C:\Python\env1\lib\site-packages\pymysql\connections.py", line 517, in query
    self._affected_rows = self._read_query_result(unbuffered=unbuffered)
    File "C:\Python\env1\lib\site-packages\pymysql\connections.py", line 732, in _read_query_result
    result.read()
    File "C:\Python\env1\lib\site-packages\pymysql\connections.py", line 1075, in read
    first_packet = self.connection._read_packet()
    File "C:\Python\env1\lib\site-packages\pymysql\connections.py", line 684, in _read_packet
    packet.check_error()
    File "C:\Python\env1\lib\site-packages\pymysql\protocol.py", line 220, in check_error
    err.raise_mysql_exception(self._data)
    File "C:\Python\env1\lib\site-packages\pymysql\err.py", line 109, in raise_mysql_exception
    raise errorclass(errno, errval)
    django.db.utils.ProgrammingError: (1146, "Table 'test_test.sqltes' doesn't exist")

    ----------------------------------------------------------------------
    Ran 1 test in 0.349s

    FAILED (errors=1)
    Destroying test database for alias 'default'...
    ```
    一番最初に b.save()を入れてない状態で python manage.py test myapp1をしたときはうまくいったのですが、その後 saveをしていないことに気づき、更新されていなかったため、b.save()を追加したらエラーが出るようになりました。
    大変申し訳ございませんが、ご回答お願い致します。

    キャンセル

  • 2019/03/11 17:30

    ```django
    b = Sqltes.objects.get(pk=4)
    ```
    どうやら上記のデータの呼び出しでも同じようなエラーが来たためデータベースにアクセスしようとするとエラーが起きるようです

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 89.85%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

同じタグがついた質問を見る